{{- if .Values.metrics.enabled }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ printf "%s-metrics" (include "nextcloud.fullname" .) }}
  namespace: {{ .Release.Namespace }}
  labels:
    app.kubernetes.io/name: {{ printf "%s-metrics" (include "nextcloud.fullname" .) }}
    {{- include "nextcloud.labels" . | nindent 4 }}
    app.kubernetes.io/component: metrics
spec:
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ printf "%s-metrics" (include "nextcloud.fullname" .) }}
      {{- include "nextcloud.selectorLabels" . | nindent 6 }}
      app.kubernetes.io/component: metrics
  replicas: {{ .Values.metrics.replicaCount }}
  strategy:
    {{- with .Values.metrics.strategy }}
        {{- toYaml . | nindent 4 }}
    {{- end }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ printf "%s-metrics" (include "nextcloud.fullname" .) }}
        {{- include "nextcloud.labels" . | nindent 8 }}
        app.kubernetes.io/component: metrics
        app.kubernetes.io/version: {{ .Values.metrics.image.tag }}
    spec:
      serviceAccountName: {{ include "nextcloud.serviceAccountName" . }}
      containers:
        - name: {{ printf "%s-metrics" (include "nextcloud.fullname" .) }}
          image: "{{ .Values.metrics.image.repository }}:{{ .Values.metrics.image.tag }}"
          imagePullPolicy: {{ .Values.metrics.image.pullPolicy }}
          env:
            - name: NEXTCLOUD_AUTH_TOKEN
            {{- if .Values.metrics.config.existingSecret.enabled }}
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.metrics.config.existingSecret.name }}
                  key: {{ .Values.metrics.config.existingSecret.tokenKey }}
            {{- else if not .Values.metrics.config.token }}
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-metrics" (include "nextcloud.fullname" .) }}
                  key: token
            {{- else }}
              value: {{ .Values.metrics.config.token }}
            {{- end }}
            - name: NEXTCLOUD_SERVER
              value: {{ printf "http://%s-nginx" (include "nextcloud.fullname" .) }}
            - name: NEXTCLOUD_TIMEOUT
              value: {{ .Values.metrics.timeout }}
          ports:
            - name: metrics
              containerPort: 9205
          {{- if .Values.metrics.startupProbe.enabled }}
          startupProbe:
            {{- omit .Values.metrics.startupProbe "enabled" | toYaml | nindent 12 }}
            tcpSocket:
              port: metrics
          {{- end }}
          {{- if .Values.metrics.readinessProbe.enabled }}
          readinessProbe:
            {{- omit .Values.metrics.readinessProbe "enabled" | toYaml | nindent 12 }}
            tcpSocket:
              port: metrics
          {{- end }}
          {{- if .Values.metrics.livenessProbe.enabled }}
          livenessProbe:
            {{- omit .Values.metrics.livenessProbe "enabled" | toYaml | nindent 12 }}
            tcpSocket:
              port: metrics
          {{- end }}
          resources:
            {{- toYaml .Values.metrics.resources | nindent 12 }}
          securityContext:
            runAsUser: 2000
            runAsNonRoot: true
{{- end }}
